// this is a very basic template. use it to start writing your own effects.
// if you want effects with lighting start from one of the GouraudXXXX or PhongXXXX effects

// --------------------------------------------------------------------------------------------------
// PARAMETERS:
// --------------------------------------------------------------------------------------------------

//transforms
float4x4 tW: WORLD;        //the models world matrix
float4x4 tV: VIEW;         //view matrix as set via Renderer (EX9)
float4x4 tP: PROJECTION;
float4x4 tWVP: WORLDVIEWPROJECTION;
float4x4 tWV: WORLDVIEW;
float4x4 tITWV: WORLDVIEWINVERSETRANSPOSE;

float farClip <string uiname="Far Clip";> = 1.0;

struct vs2ps
{
   float4 Pos: POSITION;
   float4 TexCd: TEXCOORD0;
};

// --------------------------------------------------------------------------------------------------
// VERTEXSHADERS
// --------------------------------------------------------------------------------------------------
vs2ps DepthVertexShader(float4 Pos: POSITION)
{
   vs2ps In = (vs2ps) 0;
   In.Pos = mul(Pos, tWVP);
   In.TexCd = mul(Pos, tWVP);
   return In;
}


// --------------------------------------------------------------------------------------------------
// PIXELSHADERS:
// --------------------------------------------------------------------------------------------------
float4 DepthPixelShader(vs2ps In) : COLOR
{
    float depth = In.TexCd.z / farClip;
    return float4(depth, depth, depth, 1);
}


// --------------------------------------------------------------------------------------------------
// TECHNIQUES:
// --------------------------------------------------------------------------------------------------

technique Depth
{
    pass P0
    {
        //Wrap0 = U;  // useful when mesh is round like a sphere
        VertexShader = compile vs_3_0 DepthVertexShader();
        PixelShader  = compile ps_3_0 DepthPixelShader();
    }
}
